/*
	Author: Thomas Luckart
	Copyright (c) 2010
	Unauthorized use is prohibited, without prior written permission.
*/
// the script file...
System.Gadget.settingsUI = "Prefs.html";
window.attachEvent("onload", setUpGadget);
System.Gadget.onSettingsClosed = updateSettings;

System.Gadget.onShowSettings = OnShowSettings;


var wmiInterface = GetObject("winmgmts:{impersonationLevel=impersonate}!//./root/cimv2");
var SpeedFan = GetLibrary();

var CoreTempIndx = [0];
var watchAdapterName = "Auto";
var themeColor = "000055";
var DischargeTime = "None";
var onBatteryTime = null;
var lastPercentTime = null;
var lastPercent = null;
var isOnline = true;
var bytesIn = 0;
var bytesOut = 0;
var avgBytesIn = 0;
var avgBytesOut = 0;
var coreAverage = [0];
var refreshTimerID = null;
var PowerSave = false;

// phail phail JavaScript
for(i = 0; i < numCores; i++){
	coreAverage[i] = 0;
	CoreTempIndx[i] = 0;
}

function updateSettings() {
	
	// get the settings from the setting fly-out
	for(i = 0; i < numCores; i++){
		CoreTempIndx[i] = parseInt(System.Gadget.Settings.readString("Core"+i+"TempIndx"));
	}
	watchAdapterName = System.Gadget.Settings.readString("AdapterName");
	themeColor = System.Gadget.Settings.readString("ThemeColor");
	if(watchAdapterName == '')
		watchAdapterName = 'Auto';
	if(themeColor == '')
		themeColor = '000055';
	
	onRefresh();
	onWirelessChange();
	onPowerLineChange();
	onThemeChange();

	if(watchAdapterName == "Auto")
		networkWatchText.innerText = "Monitoring: All Adapters";
	else if(watchAdapterName == "Ethernet")
		networkWatchText.innerText = "Monitoring: Ethernet Adapters";
	else if(watchAdapterName == "Wireless")
		networkWatchText.innerText = "Monitoring: Wireless Adapters";
	else
		networkWatchText.innerText = "Monitoring: " + watchAdapterName;
	
	refreshTimerID = setInterval("onRefresh()", 750);
	return;
}

var powerLineStatus = false;
var lastSSID = "~~Foobar~~";
var lastSignal = -1;
function onRefresh(){
	
	updateStats();
	if(System.Machine.PowerStatus.isPowerLineConnected != powerLineStatus){
		powerLineStatus = System.Machine.PowerStatus.isPowerLineConnected;
		onPowerLineChange();
	}
	if(System.Network.Wireless.ssid != lastSSID){
		lastSSID = System.Network.Wireless.ssid;
		onWirelessChange();
	}
	if(System.Network.Wireless.signalStrength != lastSignal){
		lastSignal = System.Network.Wireless.signalStrength;
		onSignalChange();
	}
	
//		updateInfo();
//	round = (round+1)%4;
	//setTimeout("onRefresh()", 500);
	return;
}

function onVisibilityChanged(){
	//debugLog("###onVisibilityChanged###");
	if(System.Gadget.visible){
		if(refreshTimerID == null)
			refreshTimerID = setInterval(onRefresh, 750);
		// else do nothing (suppress)
	} else { // not visible
		if(refreshTimerID != null){ // the timer must be running
			clearInterval(refreshTimerID);
			refreshTimerID = null;
		}
	}
	return;
}

function OnShowSettings(){
	if(refreshTimerID != null){
		clearInterval(refreshTimerID);
		refreshTimerID = null;
	}
}

var lastColor = '~~Foobar~~';
function onThemeChange(){
	if( themeColor != lastColor) {
		System.Gadget.beginTransition();
		BodyTop.src = './imgBack/' + themeColor + '_Topper.png';
		BodyEnd.src = './imgBack/' + themeColor + '_Bottom.png';
		BodyMiddle.style.backgroundImage = 'url("./imgBack/' + themeColor + '_Slice.png")';
		System.Gadget.endTransition(1, 1);
		lastColor == themeColor;
	}
}
function ShowElem(elem){
	elem.style.visibility = "visible";
}
function HideElem(elem){
	elem.style.visibility = "hidden";
}

function SetVPos(elem1, elem2, xOffset){
	var newTop = parseInt(elem2.style.top) + xOffset;
	debugLog(elem2.style.top.toString());
	if(newTop > 0)
		elem1.style.top = newTop;
}
function verifyUsage(usage) {
    if(usage == null)
        return 0;
    if(usage <= 0)
        return 0;
    if(usage > 100)
		return 100;
    return usage;
}



function updatesViaWMI() {
	if(PowerSave) return;
		var wheres;
		if(watchAdapterName == "Auto")
			wheres = "name LIKE '%Ethernet%' OR name LIKE '%Wireless%'";
		else if(watchAdapterName == "Ethernet")
			wheres = "name LIKE '%Ethernet%'";
		else if(watchAdapterName == "Wireless")
			wheres = "name LIKE '%Wireless%'";
		else
			wheres = "name = '" + watchAdapterName + "' LIMIT 1";

		//if(!isOnline)return; // if not online don't do the check
		data = wmiInterface.ExecQuery("Select BytesReceivedPerSec,BytesSentPerSec From Win32_PerfFormattedData_Tcpip_NetworkInterface WHERE " + wheres);
		dataEnum = new Enumerator(data);
		dataEnum.moveFirst();
		bytesIn = 0;
		bytesOut = 0;
		while(!dataEnum.atEnd()){
			if(dataEnum.item() != null){
				if( dataEnum.item().BytesReceivedPerSec != null)
					bytesIn += parseInt(dataEnum.item().BytesReceivedPerSec);
				if( dataEnum.item().BytesSentPerSec != null)
					bytesOut += parseInt(dataEnum.item().BytesSentPerSec);
				//if(dataEnum.item().Caption != null)
				//	debugLog(dataEnum.item().Caption);
			}
			dataEnum.moveNext();
		}
		return;
	// all done
}

function convertTime(minutes) {
	hours = Math.floor(minutes / 60);
	minutes %= 60;
	if(minutes < 10){
		minutes = "0" + minutes;
	}
	return hours + ":" + minutes;
}

function computeTxStr(bytesTx){
	postFix = "B/s";
	if( (bytesTx/1024/1024) >= 1){ // to MB/s
		bytesTx /= 1024;
		bytesTx /= 1024;
		postFix = "MB/s";
	} else if( (bytesTx/1024) >= 1){
		bytesTx /= 1024;
		postFix = "KB/s";
	}
	digits = 3;
	if(Math.floor(bytesTx) >= 10)
		digits -= 1;
	if(Math.floor(bytesTx) >= 100)
		digits -= 1;
	return bytesTx.toFixed(digits) + postFix;
}

var powerLineTimer = null;
//var lastChargeUpdate = null;
//var lastCapacity = null;
function onPowerLineChange(){
	debugLog("#####onPowerLineChange#####");
	if(System.Machine.PowerStatus.isPowerLineConnected){
		debugLog("powerLineConnected!");
		// clean up...
		if(powerLineTimer != null)
			window.clearInterval(powerLineTimer);
		onBatteryTime = null;
		// initial run...
		updateChargeTime();
		// set to run on the interval...
		powerLineTimer = window.setInterval(updateChargeTime, 1000);
	} else {
		debugLog("powerLineDisconnected!");
		// clean up from when we were connected to the power cord...
		if(powerLineTimer != null)
			window.clearInterval(powerLineTimer);
		lastPercent = null;
		lastPercentTime = null;
		//lastChargeTime = null;
		//lastCapacity = null;
		// run the battery function the initial time...
		updateBatteryTime();
		// set the update function to be repeated on the interval
		powerLineTimer = window.setInterval(updateBatteryTime, 1000);
	}
}

function updateBatteryPercent(){
	curPercent = verifyUsage(System.Machine.PowerStatus.batteryPercentRemaining);
	batteryMeter.style.width = curPercent/2;
	batteryText.innerText = curPercent + "% ";
	
	if(curPercent > 66){
		batteryImg.src = "./barblue.png";
	} else if(curPercent > 33){
		batteryImg.src = "./baryellow.png";
	} else if(curPercent > 10){
		batteryImg.src = "./barorange.png"
	} else {
		batteryImg.src = "./barred.png";
	}
}


function updateChargeTime(){
	curPercent = verifyUsage(System.Machine.PowerStatus.batteryPercentRemaining);
	
	if(System.Machine.PowerStatus.isBatteryCharging){
	
		if(lastPercent == null){
			lastPercent = curPercent;
			lastPercentTime = new Date();
			updateBatteryPercent();
			batteryText.innerText += "(~~~~)";
		} else{
			if(lastPercent != curPercent){
				curTime = new Date();
				deltaTime = curTime.getTime() - lastPercentTime.getTime();
				deltaTime = deltaTime / (curPercent-lastPercent);
				timeLeft = Math.ceil((deltaTime * (100-curPercent)) / 1000 / 60);
				updateBatteryPercent();
				batteryText.innerText += "(~" + timeLeft + "M)";
				lastPercent = curPercent;
				lastPercentTime = curTime;
			}
		}
	} else {
		updateBatteryPercent();

		if(System.Machine.PowerStatus.batteryPercentRemaining != 100)
			batteryText.innerText += "(~!~)";
		else {
			if(System.Machine.PowerStatus.isPowerLineConnected){
				window.clearInterval(powerLineTimer);
				powerLineTimer = null;
			}
			batteryText.innerText += "(Full)";
		}
	}
}

function updateBatteryTime(){
	updateBatteryPercent();

	// go get the discharge time from the WMI interface
	var data = wmiInterface.ExecQuery("Select EstimatedRunTime From Win32_Battery");

	var dataEnum = new Enumerator(data);
	for (; !dataEnum.atEnd(); dataEnum.moveNext()){
		if(dataEnum.item().EstimatedRunTime != 71582788)
			batteryText.innerHTML += "(" + convertTime(dataEnum.item().EstimatedRunTime) + ")";
			// some random constant that the RunTime is when it hasn't been computered yet
		else
			batteryText.innerHTML += "(~~~)";
	}
	
	//batteryStatus.innerText = System.Machine.PowerStatus.batteryCapacityRemaining + " remaining";
	
	if(onBatteryTime == null)
		onBatteryTime = new Date();
	else {
		curTime = new Date();
		timeInSec = Math.floor((curTime.getTime() - onBatteryTime.getTime()) / 1000);
		timeInMin = Math.floor(timeInSec/60);
		timeInSec = timeInSec - timeInMin*60;
		timeInHr = Math.floor(timeInMin/60);
		timeInMin = timeInMin - timeInHr*60;
		batteryText.innerText +=  "("+ timeInHr + ":";
		batteryText.innerText += timeInMin + ":";
		batteryText.innerText += timeInSec + ")";
	}
}

function onWirelessChange(){
	if(System.Network.Wireless.ssid != ""){
		if(!isOnline){
			isOnline = true;
			/*if(!PowerSave){
				upArrow.style.visibility = "visible";
				upstreamBytes.style.visibility = "visible";
				downArrow.style.visibility = "visible";
				downstreamBytes.style.visibility = "visible";
				upstreamGraph.style.visibility = "visible";
				upstreamBG.style.visibility = "visible";
				downstreamGraph.style.visibility = "visible";
				downstreamBG.style.visibility = "visible";
			}*/
		}		
		wirelessText.innerText = System.Network.Wireless.ssid;
		if(System.Network.Wireless.secureConnection == true)
			wirelessIcon.style.visibility = "visible";
		else
			wirelessIcon.style.visibility = "hidden";
	} else {
		wirelessText.innerText = "No Network";
		wirelessIcon.style.visibility = "hidden";
		/*if(isOnline){
			isOnline = false;
			upArrow.style.visibility = "hidden";
			upstreamBytes.style.visibility = "hidden";
			downArrow.style.visibility = "hidden";
			downstreamBytes.style.visibility = "hidden";
			upstreamGraph.style.visibility = "hidden";
			upstreamBG.style.visibility = "hidden";
			downstreamGraph.style.visibility = "hidden";
			downstreamBG.style.visibility = "hidden";
		}*/
	}
}

function onSignalChange(){
	if(System.Network.Wireless.signalStrength != null){
		wirelessMeter.style.width = System.Network.Wireless.signalStrength/2;
		wirelessMeter.firstChild.alt = String(System.Network.Wireless.signalStrength);
	}
}

function updateStats(){
	updatesViaWMI();

	try { SpeedFan.Refresh(); } catch(err){}
	
	for(i = 0; i < numCores; i++){
		var coreUsage = verifyUsage(parseInt(System.Machine.CPUs.item(i).usagePercentage));
		coreAverage[i] = Math.floor((coreAverage[i]*3+coreUsage)/4);
		var meter = document.getElementById("Core"+i+"Meter");
		meter.style.width = coreUsage/2;
		meter = document.getElementById("Core"+i+"AvgMeter");
		meter.style.width = coreAverage[i]/2;
		var coreTemp = 0;
		try {
			coreTemp = parseInt(SpeedFan.GetTemperature(CoreTempIndx[i]));
		} catch(err) {}
		var coreText;
		if(coreTemp != 0) coreText = "C" + (i+1) + " ["+coreTemp+"C]:";
		else coreText = "C"+(i+1)+":";
		if(coreUsage < 10) coreText += "0";
		coreText += coreUsage;
		coreText += "(";
		if( coreAverage[i] < 10) coreText += "0";
		coreText += coreAverage[i] + ")%";
		document.getElementById("Core"+i+"Text").innerText = coreText;
	}		
	
	freeMemory = parseInt(System.Machine.availableMemory);
	memUsage = 100 - Math.round((System.Machine.availableMemory / System.Machine.totalMemory)*100);
	
	ramMeter.style.width = memUsage/2;
	ramText.innerText = memUsage + "% F:" + freeMemory + "MB";
	
	
	//if(isOnline){
		 
		downstreamText.innerText = computeTxStr(bytesIn);
		upstreamText.innerText = computeTxStr(bytesOut);
		
		if(avgBytesOut == 0 || bytesOut == 0)
			upstreamMeter.style.width = 1;
		else {
			deltaBandwidth = (100*(Math.abs(avgBytesOut-bytesOut)/avgBytesOut));
			if(deltaBandwidth > 100)
				deltaBandwidth = 100;
			upstreamMeter.style.width = deltaBandwidth/2;
		}
		if(avgBytesIn == 0 || bytesIn == 0)
			downstreamMeter.style.width = 1;
		else {
			deltaBandwidth = (100*(Math.abs(avgBytesIn - bytesIn) / avgBytesIn));
			if(deltaBandwidth > 100)
				deltaBandwidth = 100;
			downstreamMeter.style.width = deltaBandwidth/2;
		}
		if(bytesIn != 0)
			avgBytesIn = Math.floor((avgBytesIn*3 + bytesIn) / 4);
		if(bytesOut != 0)
			avgBytesOut = Math.floor((avgBytesOut*3 + bytesOut) / 4);
	//}
	
	// do refresh...

}

function setUpGadget() {
	window.detachEvent("onload", setUpGadget);
	CreateLayout();
	System.Machine.PowerStatus.powerLineStatusChanged = onPowerLineChange;
	System.Network.Wireless.connectionChanged = onWirelessChange;
	System.Network.Wireless.signalStrengthChanged = onSignalChange;
	System.Gadget.visibilityChanged = onVisibilityChanged;

	//sleep(3000);
//	updatesViaWMI();
	updateSettings();
}

function ToggleLowPowerMode(){
	return;
	/*PowerSave = !PowerSave;
	if(PowerSave){
		System.Gadget.beginTransition();
		powerSaveButton.value = "Power Save: Off";
		// hide bandwidth info
		HideElem( upArrow);
		HideElem( upstreamBytes);
		HideElem( downArrow);
		HideElem( downstreamBytes);
		HideElem( upstreamGraph);
		HideElem( upstreamBG);
		HideElem( downstreamGraph);
		HideElem( downstreamBG);
		// move the button
		powerSaveButton.style.top = 106;
		// all done
		System.Gadget.background = "./shortBackground.png";
		//document.body.style.backgroundImage = "./shortBackground.png";
		document.body.style.width = 130;
		document.body.style.height = 135;
		//System.Gadget.background.addGlow(Color(255, 0, 0, 51), 50, 30);
		System.Gadget.endTransition(1, 1);
	} else {
		// restore the defaults
		System.Gadget.beginTransition();
		powerSaveButton.value = "Power Save: On";
		// show bandwidth info
		if(isOnline){
			ShowElem( upArrow);
			ShowElem( upstreamBytes);
			ShowElem( downArrow);
			ShowElem( downstreamBytes);
			ShowElem( upstreamGraph);
			ShowElem( upstreamBG);
			ShowElem( downstreamGraph);
			ShowElem( downstreamBG);
		}
		// move the power button
		powerSaveButton.style.top = 130;
		// all done
		System.Gadget.background = "./background2.png";
		document.body.style.width = 130;
		document.body.style.height = 160;
		System.Gadget.endTransition(1, 1);
	}*/
}
		
		