/*
	Author: Thomas Luckart
	Copyright (c) 2010
	Unauthorized use is prohibited, without prior written permission.
*/

var numCores = System.Machine.CPUs.count;

function NewDiv(){ return document.createElement("div"); }
function NewImg(){ return document.createElement("img"); }

function NewStat(baseName, color, isAvg, initText, textColor, iconFile, iconID){
	var stat = NewDiv();
	stat.className = "stat";
	stat.id = baseName + "Stat";
	
	var barDiv = NewDiv();
	barDiv.className = "bars";
	
	var bgBar = NewDiv();
	bgBar.className = "statBG";
	var img = NewImg();
	img.src = "./barback.png";
	bgBar.appendChild(img);
	barDiv.appendChild(bgBar);
	
	if(isAvg){
		var nowBar = NewDiv();
		nowBar.className = "statActual";
		nowBar.id = baseName + "Meter";
		img = NewImg();
		img.src = "./bar" + color + ".png";
		nowBar.appendChild(img);
		barDiv.appendChild(nowBar);
		
		var avgBar = NewDiv();
		avgBar.className = "statAvg";
		avgBar.id = baseName + "AvgMeter";
		img = NewImg();
		img.src = "./barorange.png";
		avgBar.appendChild(img);
		barDiv.appendChild(avgBar);
	} else {
		var fgBar = NewDiv();
		fgBar.className = "statFG";
		fgBar.id = baseName + "Meter";
		img = NewImg();
		img.src = "./bar" + color + ".png";
		fgBar.appendChild(img);
		barDiv.appendChild(fgBar);
	}
	stat.appendChild(barDiv);
	
	if(iconFile != null){
		var iconDiv = NewDiv();
		iconDiv.className = "statIcon";
		if(iconID != null)
			iconDiv.id = iconID;
		img = NewImg();
		img.src = iconFile;
		iconDiv.appendChild(img);
		stat.appendChild(iconDiv);
	}
	var text = NewDiv();
	text.className = "percentText";
	text.id = baseName + "Text";
	if(textColor != null)
		text.style.color = textColor;
	text.innerHTML = initText;
	stat.appendChild(text);
	BodyMiddle.appendChild(stat);
	return;
}


//var BodyTop = null;
//var BodyEnd = null;
function CreateLayout(){
	System.Gadget.beginTransition();
	var colors =    Array("blue",    "green",   "red",     "yellow",  "orange");
	var numColors = Array("#3399FF", "#00CC00", "#FF6633", "#CCFF00", "#FFCC00");
	
	//BodyTop = backContainer.addImageObject('file://imgBack/000055_Topper.png', 0, 0);
	//BodyEnd = backContainer.addImageObject('file://imgBack/000055_Bottom.png', 0, (14 * (numCores + 6) + 19) );
	
	backContainer.blur = 5;
	BodyEnd.style.top = (14 * (numCores + 6) - 1) + "px";
	BodyMiddle.style.height = (14 * (numCores + 6) + 2) + "px"; // 12px tall times the number of cores plus 6 other stats
	document.body.style.height = ((14 * (numCores + 6))+ 40) + "px";

	for(i = 0; i < numCores; i++){
		NewStat("Core" + i, colors[ i%4 ], true, "No Data", numColors[ i%4 ]);
	}
	NewStat("ram", "orange", false, "00% F:0000MB", numColors[4]);
	NewStat("wireless", "blue", false, "No SSID", numColors[0], "./lock.png", "wirelessIcon");
	var netWatch = NewDiv();
	netWatch.className = "stat";
	netWatch.id = "networkWatchText";
	netWatch.style.color = numColors[0];
	netWatch.innerHTML = "Monitoring: No Adapters";
	BodyMiddle.appendChild(netWatch);
	NewStat("upstream", "green", false, "0.000MB/s", numColors[1], "./arrow_up_green.png");
	NewStat("downstream", "yellow", false, "0.000MB/s", numColors[3], "./arrow_down_blue.png");
//	bottom.style.top = (14 * (numCores + 6) + 18) + 'px';
//	bottom.src = ''; bottom.src = './bottom.png';
	System.Gadget.endTransition(1,1);
}